<?php
/**
 * Class which returns the class map definition
 * @package
 */
class ClassMap
{
    /**
     * Returns the mapping between the WSDL Structs and generated Structs' classes
     * This array is sent to the \SoapClient when calling the WS
     * @return string[]
     */
    final public static function get()
    {
        return array(
            'CheckGenerateLabelRequestType' => '\\StructType\\CheckGenerateLabelRequestType',
            'outputFormat' => '\\StructType\\OutputFormat',
            'letter' => '\\StructType\\Letter',
            'service' => '\\StructType\\Service',
            'parcel' => '\\StructType\\Parcel',
            'customsDeclarations' => '\\StructType\\CustomsDeclarations',
            'contents' => '\\StructType\\Contents',
            'article' => '\\StructType\\Article',
            'category' => '\\StructType\\Category',
            'original' => '\\StructType\\Original',
            'importerAddress' => '\\StructType\\ImporterAddress',
            'sender' => '\\StructType\\Sender',
            'address' => '\\StructType\\Address',
            'addressee' => '\\StructType\\Addressee',
            'codSenderAddress' => '\\StructType\\CodSenderAddress',
            'uploadDocument' => '\\StructType\\UploadDocument',
            'fields' => '\\StructType\\Fields',
            'field' => '\\StructType\\Field',
            'GenerateCN23RequestType' => '\\StructType\\GenerateCN23RequestType',
            'GenerateLabelRequestType' => '\\StructType\\GenerateLabelRequestType',
            'GetListMailBoxPickingDatesRetourRequestType' => '\\StructType\\GetListMailBoxPickingDatesRetourRequestType',
            'GetProductInterRequestType' => '\\StructType\\GetProductInterRequestType',
            'planPickupRequestType' => '\\StructType\\PlanPickupRequestType',
            'getListMailBoxPickingDates' => '\\StructType\\GetListMailBoxPickingDates',
            'getListMailBoxPickingDatesRetourRequest' => '\\StructType\\GetListMailBoxPickingDatesRetourRequest',
            'getListMailBoxPickingDatesResponse' => '\\StructType\\GetListMailBoxPickingDatesResponse',
            'GetListMailBoxPickingDatesResponseType' => '\\StructType\\GetListMailBoxPickingDatesResponseType',
            'baseResponse' => '\\StructType\\BaseResponse',
            'Message' => '\\StructType\\Message',
            'generateLabel' => '\\StructType\\GenerateLabel',
            'generateLabelRequest' => '\\StructType\\GenerateLabelRequest',
            'generateLabelResponse' => '\\StructType\\GenerateLabelResponse',
            'GenerateLabelV2ResponseType' => '\\StructType\\GenerateLabelV2ResponseType',
            'xmlV2Response' => '\\StructType\\XmlV2Response',
            'xmlResponse' => '\\StructType\\XmlResponse',
            'belgiumLabel' => '\\StructType\\BelgiumLabel',
            'codeVAS' => '\\StructType\\CodeVAS',
            'returnAddressBelgium' => '\\StructType\\ReturnAddressBelgium',
            'elementVisual' => '\\StructType\\ElementVisual',
            'pickupLocation' => '\\StructType\\PickupLocation',
            'addressPickupLocation' => '\\StructType\\AddressPickupLocation',
            'routing' => '\\StructType\\Routing',
            'site' => '\\StructType\\Site',
            'addressPCH' => '\\StructType\\AddressPCH',
            'swissLabel' => '\\StructType\\SwissLabel',
            'zoneRouting' => '\\StructType\\ZoneRouting',
            'zoneCABRoutage' => '\\StructType\\ZoneCABRoutage',
            'zoneInfosRoutage' => '\\StructType\\ZoneInfosRoutage',
            'labelV2Response' => '\\StructType\\LabelV2Response',
            'labelResponse' => '\\StructType\\LabelResponse',
            'planPickup' => '\\StructType\\PlanPickup',
            'planPickupRequest' => '\\StructType\\PlanPickupRequest',
            'planPickupResponse' => '\\StructType\\PlanPickupResponse',
            'planPickupResponseType' => '\\StructType\\PlanPickupResponseType',
            'checkGenerateLabel' => '\\StructType\\CheckGenerateLabel',
            'checkGenerateLabelRequest' => '\\StructType\\CheckGenerateLabelRequest',
            'checkGenerateLabelResponse' => '\\StructType\\CheckGenerateLabelResponse',
            'CheckGenerateLabelResponseType' => '\\StructType\\CheckGenerateLabelResponseType',
            'getProductInter' => '\\StructType\\GetProductInter',
            'getProductInterRequest' => '\\StructType\\GetProductInterRequest',
            'getProductInterResponse' => '\\StructType\\GetProductInterResponse',
            'GetProductInterResponseType' => '\\StructType\\GetProductInterResponseType',
            'generateBordereauByParcelsNumbers' => '\\StructType\\GenerateBordereauByParcelsNumbers',
            'generateBordereauParcelNumberList' => '\\StructType\\GenerateBordereauParcelNumberList',
            'generateBordereauByParcelsNumbersResponse' => '\\StructType\\GenerateBordereauByParcelsNumbersResponse',
            'bordereauResponse' => '\\StructType\\BordereauResponse',
            'bordereau' => '\\StructType\\Bordereau',
            'bordereauHeader' => '\\StructType\\BordereauHeader',
            'generateCN23' => '\\StructType\\GenerateCN23',
            'generateCN23Request' => '\\StructType\\GenerateCN23Request',
            'generateCN23Response' => '\\StructType\\GenerateCN23Response',
            'GenerateCN23V2ResponseType' => '\\StructType\\GenerateCN23V2ResponseType',
            'getBordereauByNumber' => '\\StructType\\GetBordereauByNumber',
            'getBordereauByNumberResponse' => '\\StructType\\GetBordereauByNumberResponse',
        );
    }
}
